#ifndef LUA_HPP
#define LUA_HPP LuaTarget

struct LuaTarget: Target {
    void on(const StandardComponents::Define &parseComponent) override {
        if (parseComponent.final) output << "local ";
        output << parseComponent.name;
        if (parseComponent.final) output << " <const>"; // TODO Find an alternative to <const> for lua <5.4
        output << " = ";
    }
    void on(const StandardComponents::types::String &parseComponent) override {
        const string_view view (parseComponent.content);
        vector<size_t> interpolationVector;
        const string interpolationString = "${";
        unsigned long occurence_position = view.find(interpolationString);
        while (occurence_position != string_view::npos) {
            interpolationVector.push_back(occurence_position);
            occurence_position = view.find(interpolationString, occurence_position + interpolationString.size());
        }
        const bool multiline = view.find('\n') != string_view::npos;
        const char* openCharacters = multiline ? "[[" : "\"";
        decltype(openCharacters) closeCharacters = multiline ? "]]" : "\"";
        if (not interpolationVector.empty()) {
            unsigned long closingBrace = 0;
            for (unsigned long i = 0; cmp_less(i, interpolationVector.size()); ++i) {
                const auto& occurence = interpolationVector[i];
                if (i > 0) output << "..";
                output << openCharacters << view.substr((i > 0) ? closingBrace + 1 : 0, occurence - (closingBrace + 1)) << closeCharacters;
                closingBrace = view.find_first_of('}', occurence);
                if (closingBrace == string_view::npos) {
                    throw Yerbacon::Exception("Closing brace missing in a string");
                }
                output << ".." << view.substr(occurence + interpolationString.size(), (closingBrace - occurence) - interpolationString.size());
            }
        } else output << openCharacters << view << closeCharacters << '\n';
    }
};

#endif